/*
 MacTools.h

 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain.  You may use,
 * modify or distribute it freely.  If changes have been made to the original
 * copy, please make it clear.
 *
 *  This code is distributed in the hope that it will be useful but WITHOUT
 * ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY DISCLAIMED.
 *  This includes but is not limited to warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.

Wednesday, January 24, 2007 7:47:28 PM
*/

/* global constants */
#define _menu_apple						1
#define _menu_file						2
#define _menu_simple_edit				3

#define _alert_ask_save					130
#define _alert_splash					256
#define _dialog_document				512

#define _strlist_errors					128

/* shell constants */
#define kAllDocuments					(-2)

#if !defined(rez) && !defined(derez)

# ifndef __DIALOGS__
#  include <Dialogs.h>
# endif

# if PRAGMA_ONCE
#  pragma once
# endif

enum
{ /* menus */
	/* apple menu */
	_apple_about				= 1,
	/* - */

	/* file menu */
	_file_new					= 1,
	_file_open,
	_file_close,
	/* - */
	_file_save					= _file_close+2,
	_file_save_as,
	_file_revert,
	/* - */
	_file_quit					= _file_revert+2,

	/* simple edit menu */
	_edit_undo					= 1,
	/* - */
	_edit_cut					= _edit_undo+2,
	_edit_copy,
	_edit_paste,
	_edit_clear
};

enum
{ /* strlists */
	_errors_memory_fatal		= 0,
	_errors_memory_generic,
	_errors_memory_new_document
};

enum
{ /* document flags */
	_document_is_dialog_window	= 1,
	_document_dirty				= 0x80
};

/* globals */

extern boolean		gDone, gModal, gHasAppleEvents;

/* prototypes/main.c */

ModalFilterUPP get_general_modal_filter_upp(void);

void set_application_user_interaction(boolean self_only);

/* pass non-NULL to dialog for general event calls; result is for updates */
boolean handle_event(EventRecord *event, DialogRef dialog);

boolean handle_menu_item(long item_hit);

void wait(int tick_count);

FSSpec *prompt_for_file(const UInt8 *criteria);
int ask_save(ConstStr255Param object_name);

/* prototypes/document.c */

boolean open_document(FSSpec *file); /* pasing NULL means to ask the user */
boolean close_document(int index);
boolean update_document(int index);

int get_window_document_index(WindowRef window);
#define front_document_window()			get_window_document_index((WindowRef)-1)

#endif /*!defined(rez) && !defined(derez)*/
